<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
import { inject } from 'vue';

// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);



export default {
  components: { Multiselect },
  setup(props) {
	  const csrf = inject('csrf');
	
	  return {
	    csrf,
	  };
	},
  data() {
    return {
      products: null,
      InstitucionSancionadora: [],
	      OpcionesNotificacion: this.variables && this.variables.estadosNotificacion
	      ? this.variables.estadosNotificacion.map(item => item)
	      : [],

        OpcionesUsuarios: this.variables && this.variables.usuarios
	      ? this.variables.usuarios.map(item => item)
	      : [],

        estadoSeleccionado: this.variables?.notificacion?.estadoNotificacionId,

        usuarioSeleccionado: this.variables?.notificacion?.destinatario?.id,
        usuariosDeInstitucion: [],

        usuariosSeleccionados: [],

        notificacionId: this.variables.id,

        descripcion: this.variables.notificacion?.descripcion,

        destinatario: this.variables.notificacion?.usuario?.nombreCompleto,

        url: this.variables.notificacion?.url,

  

        usuariosIds: [],

        edicionHabilitadaDatosPersonales: false,
      camposDeshabilitadosDatosPersonales: true,

      edicionHabilitadaDatosPersonalesAdmin: false,
      camposDeshabilitadosDatosPersonalesAdmin: true,


        usuariosSeleccionadosPorInstitucion: [],

        detalle: this.variables?.notificacion?.texto,

        estadoFinalizado: this.variables?.notificacion?.estadoNotificacionId === 4 ? true : false,

        

  
    }
  },

  mounted() {
    const csrf = inject('csrf');

  },

  props: {
	    variables: Object,
      
	},

  watch: {
    
},

  methods: {

    botonEditarDatosPersonales(){
      this.edicionHabilitadaDatosPersonales = true;
      this.camposDeshabilitadosDatosPersonales = false;
    },

    botonEditarDatosPersonalesAdmin(){
      this.edicionHabilitadaDatosPersonalesAdmin = true;
      this.camposDeshabilitadosDatosPersonalesAdmin = false;

    },

    cancelarEdicion() {

      this.descripcion = this.variables.notificacion?.descripcion,
      this.estadoSeleccionado = this.variables.notificacion.estadoNotificacionId,
      this.detalle = this.variables?.notificacion.texto,
  

    this.camposDeshabilitadosDatosPersonales = true;
    this.edicionHabilitadaDatosPersonales = false;
  },

   verUrlNotificacion(){

window.open(this.url);

},

  cancelarEdicionAdmin() {

this.descripcion = this.variables.notificacion?.descripcion,
this.estadoSeleccionado = this.variables.notificacion.estadoNotificacionId,
this.detalle = this.variables?.notificacion.texto,
this.url = this.variables.notificacion?.url,


this.camposDeshabilitadosDatosPersonalesAdmin = true;
this.edicionHabilitadaDatosPersonalesAdmin = false;

},
    
  }
}
</script>

<template>
  <div class="main-content">
    <div class="page-content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <h4 class="card-title mb-4">Detalle de notificacion</h4>
                <form method="POST" :action="route('notificaciones.edit')">

                <div class="row">
                  <div class="col-md-3">
                    <div class="mb-3">
                      <label for="validationCustom04" class="form-label">Descripción</label>
                      <input name="descripcion" :disabled="camposDeshabilitadosDatosPersonalesAdmin" v-model="descripcion" type="text" class="form-control" id="validationCustom01" placeholder="Descripción"/> 
                    </div>
                  </div>
          

                  <div class="col-md-6">
                    <div class="mb-3">
                      <label for="" class="form-label">Destinatario</label>
                      <select name="destinatarioId" v-model="usuarioSeleccionado" :disabled="camposDeshabilitadosDatosPersonalesAdmin" class="form-select" id="validationCustom03" required>
                        <option v-for="opcion in OpcionesUsuarios" :value="opcion.id">{{ opcion.nombreCompleto }}</option>
                      </select>
                    </div>
                  </div>

                  <div class="col-md-3">
                    <div class="mb-3">
                      <label for="validationCustom11" class="form-label">Estado</label>
                      <select name="estadoNotificacionId" v-model="estadoSeleccionado" :disabled="camposDeshabilitadosDatosPersonales" class="form-select" id="validationCustom03" required>
                        <option v-for="opcion in OpcionesNotificacion" :value="opcion.id">{{ opcion.valor }}</option>
                      </select>
                    </div>
                  </div>

                  <div class="col-md-12">
                    <div class="mb-3">
                      <label for="exampleFormControlTextarea1">Detalle de la notificacion</label>
                      <textarea class="form-control" :disabled="camposDeshabilitadosDatosPersonalesAdmin" v-model="detalle" name="texto" rows="4"></textarea>                                        
                    </div>
                  </div>

                  <div class="col-md-12">
                    <div class="mb-3">
                      <label for="exampleFormControlTextarea1">Enlace a documento</label>
                      <div class="input-group">
                        <input name="url" v-model="url" :disabled="camposDeshabilitadosDatosPersonalesAdmin" type="text" class="form-control" placeholder="Enlace a un documento"/> 
                        <button class="btn btn-primary" id="BuscarNotificacion"  @click="verUrlNotificacion" type="button"><i class="mdi mdi-30px mdi-eye"></i></button>
                        </div>
                    </div>
                  </div>

                  <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                    <button class="btn btn-warning" type="button" v-if="!edicionHabilitadaDatosPersonales && !can('notificaciones.edit') && estadoFinalizado === false" @click="botonEditarDatosPersonales">Editar</button>
                    <button class="btn btn-danger" type="button" v-if="edicionHabilitadaDatosPersonales && !can('notificaciones.edit')" @click="cancelarEdicion">Cancelar</button>
                    <button class="btn btn-primary" type="submit" v-if="edicionHabilitadaDatosPersonales && !can('notificaciones.edit')">Guardar</button>
                    <button class="btn btn-warning" type="button" v-if="!edicionHabilitadaDatosPersonalesAdmin && can('notificaciones.edit') && estadoFinalizado === false" @click="botonEditarDatosPersonalesAdmin">Editar</button>
                    <button class="btn btn-danger" type="button" v-if="edicionHabilitadaDatosPersonalesAdmin && can('notificaciones.edit')" @click="cancelarEdicionAdmin">Cancelar</button>
                    <button class="btn btn-primary" type="submit" v-if="edicionHabilitadaDatosPersonalesAdmin && can('notificaciones.edit')">Guardar</button>


                  </div>
                </div>
                <input type="hidden" name="_token" :value="csrf"/>
                <input type="hidden" name="_method" value="PUT">
                <input type="hidden" name="id" v-model="notificacionId">

              </form>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <footer class="footer"></footer>
  </div>
</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatable-index-usuarios{
  margin-top: 10px;
}

.destinatarios{
  height: 20px;
}

.multiselect-tag{
  background: #6045ca;
}

.multiselect-wrapper {
    height: 10px;
    padding: .47rem 1.75rem .47rem .75rem;
    font-size: .8125rem;
}

#BuscarNotificacion{
  height: 40px;
}



.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
